﻿// // ******************************************************************
// //       /\ /|       @File         ExportMethod.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-05-20
// //      /  \\        @Modified      2024-05-20
// //    *(__\_\
// // ******************************************************************

#pragma once
#include <future>

#include "ProtocolDecodeBase.h"
#include "EdgePulseData.h"
#include "QuantizeParams.h"
#include "ProtocolRS232/Protocol.RS232.Options.h"
#include "ProtocolRS232/RS232DecodeResult.h"
//#include "ProtocolUSB/UsbDecodeOptions.h"
//#include "ProtocolUSB/USBDecodeResult.h"

#ifdef LIBMATH_EXPORTS
#define LIBMATH_API __declspec(dllexport)
#else
#define LIBMATH_API __declspec(dllimport)
#endif
namespace Protocol
{
    extern "C" {

    // LIBMATH_API bool Parse_USB(UsbDecodeOptions option, std::vector<Protocol::TwoLevelEdgePulse> edgePluses1,
    //                            std::vector<Protocol::TwoLevelEdgePulse> edgePluses2, UsbDecodeResult& result);


    LIBMATH_API bool Parse_RS232(const ProtocolRS232Options& options,
                                 const EdgePulseDataTwoLevels& edgePulseData,
                                 RS232DecodeResult& decodeResult);

    // LIBMATH_API bool quantizeParamsDecodeRS232(const QuantizeParams& quantizeParams,
    //                                            const ProtocolRS232Options& options,
    //                                            RS232DecodeResult& decodeResult);


    inline LIBMATH_API void setCancellationSignal(bool value)
    {
        canceled = value;
    }

    LIBMATH_API void getVersionExport(uint8_t* version);

    }
}
