﻿// // ******************************************************************
// //       /\ /|       @File         RS232Params.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-05-16
// //      /  \\        @Modified      2024-05-16
// //    *(__\_\
// // ******************************************************************

#pragma once

#include "../BaseEnums/Channels.h"
#include "ProtocolRS232Enums.h"
#include "../QuantizeParams.h"
//#include "../DecodeParams.h"

namespace Protocol
{
    struct RS232DecodeParams //:public DecodeParams
    {
        //=============== 配置参数 ==============//
        uint32_t BaudRate; //波特率
        OddEvenCheck OddEvenCheckType; //奇偶检验类型  None,Odd,Even

        Polarity Polarity; //电平极性  None, Pos,  Neg
        SignalType SignalType; //信号类型   SingleEnded单端,Diff差分
        //ChannelId Source; //信源号
        MSBOrLSB MSBOrLSB; //大小端

        RS232Enums::DataBitWidth DataBitWidth; //数据位宽
        RS232Enums::StopBit StopBit; //停止位
        float Threshold; //电平阈值

        //=============== 双电平数据 ==============//
        EdgePulseDataTwoLevels* EdgePulseData;
    };

    //整型输入参数
    class UsbQuantizedParams : QuantizeParams
    {
        //todo 整形参数
    };
}
