﻿// // ******************************************************************
// //       /\ /|       @File         ProtocolUSBEnums.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-1-3
// //      /  \\        @Modified      2024-1-15
// //    *(__\_\
// // ******************************************************************

#pragma once
#include <cstdint>

namespace Protocol
{
    class Enums
    {
    public:
        enum class USBFieldType
        {
            NoDefine = 0,
            SOP,
            SYNC,
            PID,
            ADDR,
            FRAME,
            DATA,
            CRC
        };

        enum class USBPacketType
        {
            NoDefine = 0,
            Token,
            Data,
            HandShake,
            Special,
        };

        enum class Condition
        {
            Sync,
            Reset,
            Pause,
            Resume,
            PackageEnd,
            TokenPackage,
            HandshakePackage,
            DataPackage,
            // Sof,
            Special,
            Error,
        };

        enum class SignalRate
        {
            LowRate,
            FullRate,
            HighRate,
        };

        enum class TokenPackageType //: uint8_t
        {
            Out = 0b0001,
            SOF = 0b0101,
            IN = 0b1001,
            SETUP = 0b1101,
        };

        enum class SpecialPacketType //: uint8_t
        {
            // Pre = 0b1100,
            Err = 0b1100,
            Split = 0b1000,
            Ping = 0b0100,
            Remain = 0b000,
        };

        enum class HandshakePackageType //: uint8_t
        {
            ACK = 0b0010,
            NAK = 0b1010,
            STALL = 0b1110,
            Nyet = 0b0110,
        };

        enum class DataPackageType //: uint8_t
        {
            Data0 = 0b0011,
            Data1 = 0b1011,
            Data2 = 0b0111,
            MData = 0b1111,
        };

        enum class ErrorPackageType
        {
            PIDCRC,
            CRC5,
            CRC16,
            BitFill,
        };

        enum class DataRelation
        {
            Lt,
            Gt,
            Lteq,
            Gteq,
            Eq,
            Neq,
            In,
            Out,
        };
    };
}
