﻿// // ******************************************************************
// //       /\ /|       @File         UsbDecodeResult.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-1-4
// //      /  \\        @Modified      2024-1-15
// //    *(__\_\
// // ******************************************************************

#pragma once
#include <utility>

#include "ProtocolUSBEnums.h"
#include "../DecodeResult.h"
#include "USBPacket.h"
#include "../DecodeEvent.h"

namespace Protocol
{
    class UsbDecodeResultCell : Protocol::DecodeResultCell
    {
    public:
        USBPacket GetUsbPacket() { return usbPacket; }

        UsbDecodeResultCell(USBPacket packet)
        {
            usbPacket = std::move(packet);
        }

    private:
        USBPacket usbPacket;
    };

    struct UsbDecodeResult : Protocol::DecodeResult
    {
        void Add(const UsbDecodeResultCell* cell);
 
        std::vector<UsbDecodeResultCell> DecodeResultCells;
        //std::vector<UsbDecodeEvent> DecodeEventCells; //TODO
    };
}
